//example of using 3D graphics in Processing Chapter 11, Getting Started Processing, Ben Fry

//second example: using cubes instead of rectangles and several types of lighting
import processing.opengl.*;

float cameraZ;

void setup()
{
 size(880, 440, OPENGL);
 noStroke();  
 fill(255);  
}

void draw()
{
 lights();
 
 cameraZ = (height/2.0) / tan(radians(60));
 camera(mouseX, mouseY, cameraZ, //location of camera
       width/2.0, height/2.0, 0, //target of camera (what it looks at)
       0, 1, 0); //camera orientation vector
 
 background(0);
 translate(width/2, height/2, -20);

 int dim = 18;
 for(int i = -height / 2; i < height / 2; i += dim * 1.2)
 {
  for(int j = -height / 2; j < height / 2; j+=dim * 1.2)
  {
    pushMatrix();
    translate(i, j, -j); 
    box(dim, dim, dim);
    popMatrix();
  }
 }
}   

