//EXAMPLE: EXERPT fro CHAPTER 3 FROM 'VISUALIZING DATA', O'REILLY
Table dataTable;
PImage mapImage;
Table locationTable;
int rowCount;
//setting bounds for dataset (always useful to avoid bugs)
float dataMax = MIN_FLOAT;
float dataMin = MAX_FLOAT;
float closestDist;

PFont myFont;

void setup()
{
  size(640, 400);
  mapImage = loadImage("map.png");
  locationTable = new Table("locations.tsv");
  rowCount = locationTable.getRowCount();
  
  //read  in the data
  dataTable = new Table("random.tsv");
  //find the max and min in the dataset
  for(int row = 0; row < rowCount; row++)
  {  
    float value = dataTable.getFloat(row, 1);
    if(value > dataMax)
      dataMax = value;
    if(value < dataMin)
      dataMin = value;
  }
  smooth();
  noStroke(); 

  myFont = createFont("Foo", 10); 
  textFont(myFont);
}

void draw()
{
  background(255);
  image(mapImage, 0, 0);
  closestDist = MAX_FLOAT;
   fill(192,0,0); 
  for(int row = 0; row < rowCount; row++)
  {
    String abbrev = dataTable.getRowName(row);
    float x = locationTable.getFloat(row,1);
    float y = locationTable.getFloat(row, 2);
    drawData(x,y,abbrev);
  }
}

void drawData(float x, float y, String abbrev)
{
  //get value for state
  float value = dataTable.getFloat(abbrev, 1);
  //scale
  float mapped = map(value, dataMin, dataMax, 2, 40);
  if(dist(x,y,mouseX, mouseY) < mapped)
  {
    fill(0);
    textAlign(CENTER);
    text(value + "\t" +abbrev ,x, y-mapped -5);
      fill(0, 0, 190);
  }
  ellipse(x,y,mapped,mapped);
  //red
  fill(192,0,0);
}
