import processing.core.*; 
import processing.xml.*; 

import treemap.*; 

import treemap.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class wordMap extends PApplet {

class WordMap extends SimpleMapModel
{
  HashMap words;
  
  WordMap()
  {
    words = new HashMap();
  }
  
  public void addWord(String word)
  {
    WordItem item = (WordItem) words.get(word);
    if(item == null)
    {
      item = new WordItem(word);
      words.put(word, item);
    }
    item.incrementSize();
  }
  public void finishAdd()
  {
    items = new WordItem[words.size()];
    words.values().toArray(items);
  }
}
class WordItem extends SimpleMapItem
{
  String word;
  WordItem(String word)
  {
    this.word = word;
  }

public void draw()
{
  fill(255);
  rect(x,y,w,h);
  
  fill(0);
  if(w>textWidth(word)+6)
  {
    if(h>textAscent() + 6)
    {
      textAlign(CENTER, CENTER);
      text(word, x+w/2, y + h/2);
    }
  }
}
}



Treemap map;

public void setup()
{
  size(1024, 768);
  
  smooth();
  strokeWeight(0.25f);
  PFont font = createFont("Serif", 13);
  textFont(font);
  
  WordMap mapData = new WordMap();
  //Mark Twain book
  String[] lines = loadStrings("equator.txt");
  for (int i = 0; i < lines.length; i++)
  {
    mapData.addWord(lines[i]);
  }
  mapData.finishAdd();
   
  map = new Treemap(mapData, 0, 0, width, height);
  noLoop(); //forces draw to only run once
}

public void draw()
{
  background(255);
  map.draw();
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "wordMap" });
  }
}
